-------------------------------------------------------------------
--           RAPID - RAPID ADA PORTABLE INTERFACE DESIGNER         
--           MCC GUI PACKAGE LIBRARY                               
--           Copyright (C) 1999 Martin C. Carlisle.       
--
-- Adapted from RAPID version 1.2 suggestion by W. Blair Watkinson II
--                                                                 
-- RAPID is free software;  you can  redistribute it  and/or modify
-- it under terms of the  GNU General Public License as published  
-- by the Free Software  Foundation;  either version 2,  or (at your
-- option) any later version.  RAPID is distributed in the hope that 
-- it will be useful, but WITHOUT ANY WARRANTY;  without even the 
-- implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
-- PURPOSE.  See the GNU General Public License for more details.  
-- You should have  received  a copy of the GNU General Public License
-- distributed with RAPID; see file COPYING.  If not, write to the 
-- Free Software Foundation,  59 Temple Place - Suite 330,  Boston, 
-- MA 02111-1307, USA.                                                 
--                                                                     
-- As a special exception, if other files instantiate generics from
-- this unit, or you link this unit with other files to produce an 
-- executable, this unit does not by itself cause the resulting 
-- executable to be covered by the GNU General Public License.  
-- This exception does not however invalidate any other reasons 
-- why the executable file might be covered by the GNU Public 
-- License.  This exception does not apply to executables which
-- are GUI design tools, or that could act as a replacement
-- for RAPID.
------------------------------------------------------------------------------
with Gwindows.Common_Controls;
with Peer_To_Mcc;
package body Mcc.Gui.Widget.Scale is

   ------------
   -- Create --
   ------------

   procedure Create
     (Obj                  : in out Scale;
      Parent               : in     Mcc.Gui.Container.Container'Class;
      X                    : in     Integer;
      Y                    : in     Integer;
      Width                : in     Natural;
      Height               : in     Natural;
      Min                  : in     Integer;
      Max                  : in     Integer;
      Mark_Every           : in     Natural;
      Orientation          : in     Scale_Orientation := Horizontal;
      By                   : in     Natural := 1)
   is
      My_Peer : Gwindows.Common_Controls.Trackbar_Control_Access;
      My_Direction : Gwindows.Common_Controls.Trackbar_Control_Direction_Type;
   begin
      if Orientation=Horizontal then
         My_Direction := Gwindows.Common_Controls.Horizontal;
      else
         My_Direction := Gwindows.Common_Controls.Vertical;
      end if;
      My_Peer := new Gwindows.Common_Controls.Trackbar_Control_Type;
      Gwindows.Common_Controls.Create(
         Control    => My_Peer.all,
         Parent     => Mcc.Gui.Container.Get_Peer(Parent).all,
         Left       => X,
         Top        => Y,
         Width      => Width,
         Height     => Height,
         Where      => Gwindows.Common_Controls.Bottom_Ticks,
         Direction  => My_Direction);
      Obj.My_Peer := Peer.Peer(My_Peer);
      Peer_To_Mcc.Hash_Package.Set(
         K => My_Peer.all'Address,
         E => Obj'Unrestricted_Access);
   --type Scroll_Event is access
   --  procedure (Window  : in out GWindows.Base.Base_Window_Type'Class;
   --             Request : in     Scroll_Request_Type);
   --procedure On_Horizontal_Scroll_Handler
     --(Window  : in out Base_Window_Type;
     -- Handler : in     Scroll_Event);
   end Create;

   ---------
   -- Get --
   ---------

   function Get (Obj : in Scale) return Integer is
   begin
      return Get (Obj);
   end Get;

   ------------------------
   -- Get_Scale_Listener --
   ------------------------

   function Get_Scale_Listener
     (Obj : in Scale'Class)
      return Scale_Listener
   is
   begin
      return Get_Scale_Listener (Obj);
   end Get_Scale_Listener;

   ---------
   -- Set --
   ---------

   procedure Set
     (Obj      : in out Scale;
      Location : in     Integer)
   is
   begin
      null;
   end Set;

   ------------------------
   -- Set_Scale_Listener --
   ------------------------

   procedure Set_Scale_Listener
     (Obj           : in Scale_Pointer;
      Listener      : in Scale_Listener)
   is
   begin
      null;
   end Set_Scale_Listener;

end Mcc.Gui.Widget.Scale;

